function [V,str,icon]=conn_getinfo(filename);

[pathname,name,ext]=fileparts(filename(1,:));
switch(ext(1:min(4,length(ext)))),
	case {'.img','.hdr','.nii'},
		V=spm_vol(filename);
		if length(V)==1, icon=V; 
		else, icon=V([1,end]); end
	case {'.tal','.mat','.txt'},
		icon=[];
		for n1=1:size(filename,1),
			x=load(deblank(filename(n1,:)));
			if isstruct(x), names=fieldnames(x); x=x.(names{1}); end
			V(n1).dim=size(x);
			V(n1).fname=deblank(filename(n1,:));
			if ~isstruct(x) && (n1==1 || n1==size(filename,1)),
				icon=cat(2,icon,x(:,:));
			end
		end
	otherwise,
		error(['File type ',ext,' not implemented']);
end
if isempty(V), str=[]; icon=[];
else
	str=['[',num2str(length(V)), ' file']; if length(V)>1, str=[str,'s']; end; str={[str,']']};
	if length(V)==1, str{end+1}=V(1).fname;
	else str{end+1}=['First: ',V(1).fname]; str{end+1}=['Last : ',V(end).fname];  end
	if length(V)>1 && any(any(detrend(cat(1,V(:).dim),0))),str{end+1}='Dimensions: NOT MATCHED';
	else str{end+1}=['Dimensions: ',num2str(V(1).dim,'%1.0f ')]; end
	for n1=1:length(str), if length(str{n1})>39, str{n1}=[str{n1}(1:4),' ... ',str{n1}(end-30+1:end)]; end; end; %str{n1}=[str{n1}(1:17),' ... ',str{n1}(end-17+1:end)]; end; end
end


